//P2e - Eric Withrow
// Point and vector classes inspired by Professor Jarek Rossignac

color grey = color(200, 200, 210); color red = color(200, 10, 10); color blue = color(10, 10, 200); color lightblue = color(100, 100, 255); 
color green = color(10, 200, 20); color black = color(10, 10, 10); color magenta = color(250, 150, 200); color brown = color(150, 100, 50); 
color banana = color(100, 255, 50); color white = color(250, 250, 250);

int screen_width = 800;
int screen_height = 600;
int fps = 30;
int num_people = 30;
int num_visible = 5;
/*int num_people = 2;
int num_visible = 2;*/

person[] person_arr = new person[num_people];
animation robot;

float xr, yr = 0;          // mouse coordinates relative to center of window
int pa=0, da=0, oa=0;

void setup() { 
   size(800, 600, P3D); 
  
   framerate(fps);
  
   robot = new animation();
  
   for(int i = 0; i < num_people; i++) {
      person_arr[i] = new person(robot, i);
   }
   updateVisible();
   
   /*person_arr[0].current = new pt(100,300,0);
   person_arr[0].last = person_arr[0].current.make();
   person_arr[0].destination = new pt(700,300,0);
   
   person_arr[1].current = new pt(350,255,0);
   person_arr[1].last = person_arr[0].current.make();
   person_arr[1].destination = new pt(350,255,0);*/
   
} 

void draw() { 
            
   background(white);         // paint a white background
   lights();                  // turn on ambient lighting
   
   
   xr = (mouseX/((float)screen_width)-0.5) * TWO_PI;   yr = (mouseY/((float)screen_height)-0.5) * TWO_PI;  
   rotateX(-yr/2);    rotateZ(xr/2);
   translate(0, 0,da); 
   
   drawfloor();

   //translate(screen_width/2, screen_height/2, 0.0);     // center view wrt window 
   
   //draw each person
   for(int i = 0; i < num_people; i++) {   
      person_arr[i].drawMe();
   }
   
}

void drawfloor() {
   pushMatrix();
   fill(lightblue); noStroke();
   float floorthickness = 20;
   translate(screen_width/2, screen_height/2, -floorthickness/2);
   box(screen_width, screen_height, floorthickness);
   popMatrix();
}

//goes through all the people and make sure only num_visible are visible
void updateVisible() {
  for(int i = 0; i < num_people; i++) {
      if(i < num_visible) {
         if(person_arr[i].visible == false)
            person_arr[i].setVisiblity(true);
      }
      else
        person_arr[i].setVisiblity(false);
  }
}
  
void mousePressed() {  // to do when mouse is pressed  

}

void keyPressed() {  
  if (key=='=' || key=='+') { da += 30; }
  if (key=='-' || key=='_') { da -= 30; }
  if (key=='w' || key=='W') { da += 30; }
  if (key=='q' || key=='Q') { da -= 30; }
  if (key=='a' || key=='A') { num_visible--; if(num_visible < 0) num_visible = 0; updateVisible(); }
  if (key=='s' || key=='S') { num_visible++; if(num_visible > num_people) num_visible = num_people;  updateVisible(); }
  if (key=='z' || key=='Z') { robot.lod--; if(robot.lod < 0) robot.lod = 0; }
  if (key=='x' || key=='X') { robot.lod++; if(robot.lod > 4) robot.lod = 4; }
}                                                             

//**************************************
// **** POINTS AND VECTOR CLASSES (modified for 3D by Eric Withrow)
class pt { float x,y,z; 
  pt () {x = 0; y = 0; z = 0; };
  pt (float px, float py, float pz) {x = px; y = py; z = pz;};
  pt make() {return(new pt(x,y,z));};
  void show(int r) { pushMatrix(); translate(x,y,z); noStroke(); sphere(r); popMatrix();}; 
  //void showLineTo (pt P) {line(x,y,P.x,P.y); }; 
  void setToPoint(pt P) { x = P.x; y = P.y; z = P.z;}; 
  void setTo (float px, float py, float pz) {x = px; y = py; z = pz;}; 
  void setToMouse() { x = mouseX; y = mouseY; z = 0; }; 
  void write() {println("("+x+","+y+","+z+")");};
  void addVec(vec V) {x += V.x; y += V.y; z += V.z;};
  void addScaledVec(float s, vec V) {x += s*V.x; y += s*V.y; z += s*V.z;};
  void subVec(vec V) {x -= V.x; y -= V.y; z -= V.z;};
  void vert() {vertex(x,y,z);};
  boolean isInWindow(int width, int height) {return(((x<0)||(x>width)||(y<0)||(y>height)));};
  void label(String s, vec D) {text(s, x+D.x, y+D.y, z+D.z);  };
  vec vecTo(pt P) {return(new vec(P.x-x,P.y-y,P.z-z)); };
  float disTo(pt P) {return(sqrt(sq(P.x-x)+sq(P.y-y)+sq(P.z-z))); };
  vec vecToMid(pt P, pt Q) {return(new vec((P.x+Q.x)/2.0-x, (P.y+Q.y)/2.0-y,(P.z+Q.z)/2.0-z)); };
  vec vecToProp (pt B, pt D) {
      vec CB = this.vecTo(B); float LCB = CB.norm();
      vec CD = this.vecTo(D); float LCD = CD.norm();
      vec U = CB.make();
      vec V = CD.make(); V.sub(U); V.mul(LCB/(LCB+LCD));
      U.add(V);
      return(U);  
      };  
  void addPt(pt P) {x+=P.x; y+=P.y; z+=P.z;};
  void subPt(pt P) {x-=P.x; y-=P.y; z-=P.z;};
  void mul(float f) {x*=f; y*=f; z*=f;};
  } 
  
class vec { float x,y,z; 
  vec (float px, float py, float pz) {x = px; y = py; z = pz;};
  void setTo (float px, float py, float pz) {x = px; y = py; z = pz;}; 
  vec make() {return(new vec(x,y,z));};
  //void show (pt P) { pt.show(3); line(P.x,P.y,P.x+x,P.y+y); }; //line part doesnt work for 3d
  void add(vec V) {x += V.x; y += V.y; z += V.z;};
  void addScaled(float m, vec V) {x += m*V.x; y += m*V.y; z += m*V.z;};
  void sub(vec V) {x -= V.x; y -= V.y; z -= V.z;};
  void mul(float m) {x *= m; y *= m; z *= m;};
  void div(float m) {x /= m; y /= m; z /= m;};
  void write() {println("("+x+","+y+","+z+")");};
  float norm() {return(sqrt(sq(x)+sq(y)+sq(z)));}; 
  void unit() {float n=sqrt(sq(x)+sq(y)+sq(z)); if (n>0.0001) {x/=n; y/=n; z/=n;};};
  //void left() {float w=x; x=-y; y=w;}; ????
  void back() {x= -this.x; y= -this.y; z= -this.z;};
  } 

pt midPt(pt A, pt B) {return(new pt((A.x+B.x)/2,(A.y+B.y)/2,(A.z+B.z)/2)); };
vec midVec(vec U, vec V) {return(new vec((U.x+V.x)/2,(U.y+V.y)/2,(U.z+V.z)/2)); };
float dot(vec U, vec V) {return(U.x*V.x+U.y*V.y+U.z*V.z); };

class person {
  
   pt current, destination, last;
   int speed;
   animation anim;
   int frameticker = 0;
   int pixels_per_second;
   color mycolor;
   int mysize;
   int myid;
   boolean visible = true;
   int pauseticker = 0;
   
   //constructor for a person, ties the person to an animation
   person(animation anim_obj, int id) {
      anim = anim_obj;
      myid = id;
      mycolor = color((int)random(0, 255), (int)random(0, 255), (int)random(0, 255));
      mysize = (int)random(10, 20);
      
      /*do {
        current = new pt((int)random(0, 800), (int)random(0, 600), 0);
      } while(violatesSpaceBubble(current, false));
      
      last = current.make();*/
      
      setVisiblity(false);
      destination = new pt((int)random(0, 800), (int)random(0, 600), 0);
     
      pixels_per_second = (int)random(150,400);
      //pixels_per_second = 0; need casefor this in nextframe
   }
   
   void setVisiblity(boolean val) {
     if(val == false) {
         visible = false;
      }
     else {
         visible = true;
         do {
            current = new pt((int)random(0, 800), (int)random(0, 600), 0);
          } while(violatesSpaceBubble(current, false));
      
          last = current.make();
     }
   }
   
   //update position (is called at each draw)
   void updatePosition() {

      last = current.make();

       float multiplier = destinationFactor();
       if(multiplier < 1) 
         {
         pt newcurrent = destination.make();
         newcurrent.subPt(current);
         newcurrent.mul(multiplier);
         newcurrent.addPt(current);
         
         
        if(violatesSpaceBubble(newcurrent, true)) {
        
        if(pauseticker <= 0) {
             float totalsteps = 100;
             int step = 0;    
             float radius = destinationFactor() * current.disTo(destination);
             pt minimum = current.make();
             pt potential;
             boolean firstpick = true;
             
             for(int i = 0; i < totalsteps; i++) {
                 //calculate potential
                 
                 float rotation = TWO_PI * i / totalsteps;
                 
                 float tryx = radius * cos(rotation);
                 float tryy = radius * sin(rotation);
                 
                 potential = new pt(current.x + tryx, current.y + tryy, 0);
                 
                 //put in minumum
                 if(!violatesSpaceBubble(potential, false) && (firstpick == true || 
                    potential.disTo(destination) < minimum.disTo(destination))) {
                     firstpick = false;
                     minimum = potential.make();
                 }
             }
             
             newcurrent = minimum;  
             } else {
             newcurrent = current;
             }
         }
         
         current = newcurrent;
         
         }
       else // we are sufficiently close to the destination
         {
         
         /*if(myid == 0){
         current = new pt(100,300,0);
         last = current.make();}*/
         
         destination = new pt((int)random(0, 800), (int)random(0, 600), 0);
         }
     
   }
   
   boolean violatesSpaceBubble(pt apoint, boolean initPause) {
       int distance = 50;
       
       for(int i = 0; i < num_people; i++) {   
          if(person_arr[i] != null && this.myid != person_arr[i].myid && person_arr[i].visible == true) {
              if(apoint.disTo(person_arr[i].current) < distance) {
                 
                 
                 //randomly pause one guy or the other
                 /*if(initPause && person_arr[i].pauseticker == 0) {
                     float rand = random(0, 1);
                     if(rand > .5) { //pause the other guy
                         person_arr[i].pauseticker = (int)random(5,11);
                     } else { //pause me
                         this.pauseticker = (int)random(5,11);
                     }
                 }*/
                 
                 
                 return true;
                 
                 }
          }
       }
   
       return false;
   }
   
   //returns the ratio of distance traveled per frame over total distance to destination
   float destinationFactor() {
       float distance_per_frame = pixels_per_second / fps;
       return distance_per_frame / current.disTo(destination);
   }
   
   // draws the animation frame mesh at the current position
   void drawMe() { 
       if(visible) {
           pushMatrix();
       
          fill(mycolor); noStroke();
         
           pushMatrix();
           translate(destination.x, destination.y, 0);
           sphere(15);
           noStroke();
           popMatrix();
           
           //positioning
           translate(current.x, current.y, 0.7378 * mysize); //so feet touching ground
           scale(mysize, mysize, -mysize);
           //rotate(PI/2 + atan2(destination.y-current.y, destination.x-current.x));
           rotate(PI/2 + atan2(current.y-last.y, current.x-last.x));
           beginShape(TRIANGLES); 
           pt vertextemp;
           for(int i = 0; i < anim.frames_arr[frameticker+4*anim.lod].numvertices; i++) {
               vertextemp = anim.frames_arr[frameticker+4*anim.lod].vertice_arr[i];
               vertex(vertextemp.x, vertextemp.y, vertextemp.z);
           }
           endShape();
       
           //now the position should be updated
           if(pauseticker <= 0) {
               updatePosition();
       
               if(destinationFactor() < 1) { nextFrame(); }
           } else {
               pauseticker--;
           }
       
           popMatrix();
       }
   }
   
   //flips the frame ticker so next animation frame is shown on next draw
   void nextFrame() {
   frameticker++;
       if(frameticker >= anim.num_frames)
           frameticker = 0; 
   }
   
} //End Person Class

//holds all the frames for an animation
class animation {
  int lod = 2; //range from 0 to 4
  int num_frames = 4;
  int num_lod = 5;
  String[] prefix = { "00", "01", "11", "10" };
  String[] suffix = { "05", "10", "15", "25", "35" };
  
  frame[] frames_arr = new frame[num_frames*num_lod];
  
  animation() {
      for(int i = 0; i < num_lod; i++) {
         for(int j = 0; j < num_frames; j++) {       
             loadFrame(prefix[j] + "-" + suffix[i] + ".stl", j + num_frames * i);
         }
      }
  }
  
  //loads a frame into the specified frameindex
   void loadFrame(String filename, int frameindex) { 
      String [] ss = loadStrings(filename);
      String line;
      int space1, space2, space3;
      float vx, vy, vz;
      int vertices = 0;
  
      frames_arr[frameindex] = new frame();
  
      for(int t = 3; t < ss.length; t+=7) {
        for(int v = t; v < t + 3; v++) {
         line = ss[v];
         space1 = line.indexOf(' ', 7);
         space2 = line.indexOf(' ', space1+1);
         space3 = line.indexOf(' ', space2+1);
         vx = new Float(line.substring(space1,space2).trim()).floatValue();
         vy = new Float(line.substring(space2,space3).trim()).floatValue();
         vz = new Float(line.substring(space3).trim()).floatValue();
       
         frames_arr[frameindex].vertice_arr[vertices] = new pt(vx,vy,vz);
         vertices++;
        }
      }
      
    frames_arr[frameindex].numvertices = vertices;
    //System.gc();
    }
}

//holds the triangle mesh for each frame of the person's animation
class frame {
   int maxvertices = 15000;
   int numvertices = 0;
   
   pt[] vertice_arr = new pt [maxvertices];
   
   frame() {};
}

